import java.util.ArrayList;
import processing.core.*;

/**
 * Created by jhughes on 3/7/16.
 */
public class StockSphere {

    private float phi;
    private float theta;
    private float radius;
    private float speed;
    private float size;
    private Stock underlying;
    private ArrayList<Float> pos;
    private Boolean paused = false;

    public StockSphere(float phi, float theta, float radius, float speed, float size, Stock u) {
        this.phi = phi;
        this.radius = radius;
        this.speed = speed;
        this.underlying = u;
        this.theta = theta;
        this.size = size;
        pos = new ArrayList<Float>();
        pos.add(0, 0.0f);
        pos.add(1, 0.0f);
        pos.add(2, 0.0f);
    }

    public float getPhi() {
        return phi;
    }

    public void setPhi(float phi) {
        this.phi = phi;
    }

    public float getSpeed() {
        return speed;
    }

    public void setSpeed(float speed) {
        this.speed = speed;
    }

    public float getRadius() {
        return radius;
    }

    public void setRadius(float radius) {
        this.radius = radius;
    }

    public Stock getUnderlying() {
        return underlying;
    }

    public void setUnderlying(Stock underlying) {
        this.underlying = underlying;
    }

    public float getTheta() {
        return theta;
    }

    public void setTheta(float theta) {
        this.theta = theta;
    }

    public void incrementPosition(){
        if(!paused) {
            this.theta += this.speed;
        }
    }

    public float getSize() {
        return size;
    }

    public void setSize(float size) {
        this.size = size;
    }

    public void translateSphere(float x, float y, float z){
        pos.set(0, pos.get(0) + x);
        pos.set(1, pos.get(1) + y);
        pos.set(2, pos.get(2) + z);
    }

    public ArrayList<Float> getPos() {
        return pos;
    }

    public void clearPos(){
        pos.set(0, 0.0f);
        pos.set(1, 0.0f);
        pos.set(2, 0.0f);
    }

    public Boolean getPaused() {
        return paused;
    }

    public void setPaused(Boolean paused) {
        this.paused = paused;
    }
}
