import java.math.BigDecimal;

/**
 * Created by jhughes on 2/29/16.
 */
public class Stock {
    private String symbol;
    private String name;
    private BigDecimal ask;
    private BigDecimal last;
    private BigDecimal bid;
    private BigDecimal adp_200;
    private BigDecimal adp_100;
    private BigDecimal adp_50;
    private BigDecimal adv_21;
    private BigDecimal adv_30;
    private BigDecimal adv_90;
    private BigDecimal outstanding;
    private BigDecimal marketCap;
    private BigDecimal chg;
    private BigDecimal pctchg;
    private BigDecimal volume;
    private String exchange;
    private String exchangeDesc;
    private String sector;

    public Stock(String s, double a, double l, double b){
        symbol = s;
        ask = new BigDecimal(a);
        last = new BigDecimal(l);
        bid = new BigDecimal(b);
        volume = BigDecimal.ZERO;
        adv_21 = BigDecimal.ZERO;

    }

    public Stock(){

    }

    public BigDecimal getAdv_90() {
        return adv_90;
    }

    public void setAdv_90(BigDecimal adv_90) {
        this.adv_90 = adv_90;
    }

    public BigDecimal getAdv_30() {
        return adv_30;
    }

    public void setAdv_30(BigDecimal adv_30) {
        this.adv_30 = adv_30;
    }

    public BigDecimal getAdv_21() {
        return adv_21;
    }

    public void setAdv_21(BigDecimal adv_21) {
        this.adv_21 = adv_21;
    }

    public BigDecimal getAdp_50() {
        return adp_50;
    }

    public void setAdp_50(BigDecimal adp_50) {
        this.adp_50 = adp_50;
    }

    public BigDecimal getAdp_200() {
        return adp_200;
    }

    public void setAdp_200(BigDecimal adp_200) {
        this.adp_200 = adp_200;
    }

    public BigDecimal getAdp_100() {
        return adp_100;
    }

    public void setAdp_100(BigDecimal adp_100) {
        this.adp_100 = adp_100;
    }

    public Stock(String s, String n){
        symbol = s;
        name = n;
    }

    public BigDecimal getBid() {
        return bid;
    }

    public void setBid(BigDecimal bid) {
        this.bid = bid;
    }

    public BigDecimal getAsk() {
        return ask;
    }

    public void setAsk(BigDecimal ask) {
        this.ask = ask;
    }

    public BigDecimal getLast() {
        return last;
    }

    public void setLast(BigDecimal last) {
        this.last = last;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSymbol() {
        return symbol;
    }

    public void setSymbol(String symbol) {
        this.symbol = symbol;
    }

    public String getExchange() {
        return exchange;
    }

    public void setExchange(String exchange) {
        this.exchange = exchange;
    }

    public String getExchangeDesc() {
        return exchangeDesc;
    }

    public void setExchangeDesc(String exchangeDesc) {
        this.exchangeDesc = exchangeDesc;
    }

    public String getSector() {
        return sector;
    }

    public void setSector(String sector) {
        this.sector = sector;
    }

    public BigDecimal getOutstanding() {
        return outstanding;
    }

    public void setOutstanding(BigDecimal outstanding) {
        this.outstanding = outstanding;
        this.marketCap = this.last.multiply(outstanding);
    }

    public BigDecimal getMarketCap(){
        return this.marketCap;
    }

    @Override
    public String toString() {
        return symbol;
    }

    public BigDecimal getChg() {
        return chg;
    }

    public void setChg(BigDecimal chg) {
        this.chg = chg;
    }

    public void setMarketCap(BigDecimal marketCap) {
        this.marketCap = marketCap;
    }

    public BigDecimal getPctchg() {
        return pctchg;
    }

    public void setPctchg(BigDecimal pctchg) {
        this.pctchg = pctchg;
    }

    public BigDecimal getVolume() {
        return volume;
    }

    public void setVolume(BigDecimal volume) {
        this.volume = volume;
    }
}
