/**
 * Created by jhughes on 3/1/16.
 */
import com.github.scribejava.core.model.Response;
import org.json.simple.*;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Objects;

public class TradeKingParser {

    private JSONParser jsonParser;

    public TradeKingParser(){
        jsonParser = new JSONParser();
    }

    public Stock parseQuote(Response response){
        Stock newStock = null;
        try{
            Object obj = jsonParser.parse(response.getBody());
            JSONObject fullresponse = (JSONObject) obj;
            JSONObject resp = (JSONObject) fullresponse.get("response");
            JSONObject quotes = (JSONObject) resp.get("quotes");
            JSONObject quote = (JSONObject) quotes.get("quote");

            String symbol = (String) quote.get("symbol");
            newStock = DataHandler.allStocks.get(symbol);
            if( newStock == null){
                newStock = new Stock();
                DataHandler.allStocks.put(symbol, newStock);
            }
            String name =  (String) quote.get("name");

            //average daily prices
            Double adp200 = Double.parseDouble((String) quote.get("adp_200"));
            Double adp100 = Double.parseDouble((String) quote.get("adp_100"));
            Double adp50 = Double.parseDouble((String) quote.get("adp_50"));
            newStock.setAdp_100(new BigDecimal(adp100));
            newStock.setAdp_200(new BigDecimal(adp200));
            newStock.setAdp_50(new BigDecimal(adp50));

            //average daily volums
            Double adv21 = Double.parseDouble((String) quote.get("adv_21"));
            Double adv30 = Double.parseDouble((String) quote.get("adv_30"));
            Double adv90 = Double.parseDouble((String) quote.get("adv_90"));
            newStock.setAdv_21(new BigDecimal(adv21));
            newStock.setAdv_30(new BigDecimal(adv30));
            newStock.setAdv_90(new BigDecimal(adv90));

            //ask, last, bid
            Double ask = Double.parseDouble((String) quote.get("ask"));
            Double last = Double.parseDouble((String) quote.get("last"));
            Double bid = Double.parseDouble((String) quote.get("bid"));
            newStock.setAsk(new BigDecimal(ask));
            newStock.setLast(new BigDecimal(last));
            newStock.setBid(new BigDecimal(bid));

            //exchange and exchange description
            String exch = (String) quote.get("exch");
            String exch_desc = (String) quote.get("exch_desc");
            newStock.setExchange(exch);
            newStock.setExchange(exch_desc);

            //outstanding
            Double outstanding = Double.parseDouble((String) quote.get("sho"));
            newStock.setOutstanding(new BigDecimal(outstanding));

            //change
            Double change = Double.parseDouble((String) quote.get("chg"));
            if(quote.get("chg_sign").equals("u")){
                newStock.setChg(new BigDecimal(change));
            }else if(quote.get("chg_sign").equals("d")){
                newStock.setChg(new BigDecimal(-change));
            }else if(quote.get("chg_sign").equals("e")){
                newStock.setChg(BigDecimal.ZERO);
            }

            Double pctchange =  Double.parseDouble((String) quote.get("pchg"));
            String chg =(String) quote.get("chg_sign");
            if(chg.equals("d")){
                newStock.setPctchg(new BigDecimal(-pctchange));
            }else if(chg.equals("u")){
                newStock.setPctchg(new BigDecimal(pctchange));
            }


            //current daily volume
            Double volume = Double.parseDouble((String) quote.get("vl"));
            newStock.setVolume(new BigDecimal(volume));

        }
        catch(Exception e){
            System.out.println("Parse quote error: " + e);
        }
        return newStock;
    }
}
